SystemOrganization addCategory: #'Glamour-Examples'!

Announcement subclass: #GLMItemAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

Announcement subclass: #GLMItemRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

TestCase subclass: #GLMFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMFileTest methodsFor: 'accessing' stamp: 'DamienCassou 9/23/2009 08:16'!
anyRoot
	^ GLMFile anyRoot! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:21'!
testGetASlashAtTheEndOfDirectoryNames
	self assert: (self anyRoot files allSatisfy: [:file | file isFile or: [file nameDistinguishingTypes last = $/]])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:15'!
testNameIsNeverEmpty
	self assert: (self anyRoot files allSatisfy: [:file | file name notEmpty])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:17'!
testNamesAreDifferent
	self assert: (self anyRoot files collect: [:file | file name]) asSet size equals: (self anyRoot files size)! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/23/2009 08:16'!
testRootNameIsNeverEmpty
	self assert: (GLMFile roots allSatisfy: [:file | file name notEmpty])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/23/2009 08:16'!
testRootsAreDirectories
	self assert: (GLMFile roots allSatisfy: [:ea | ea isDirectory])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/23/2009 08:15'!
testRootsAreSFile
	self assert: (GLMFile roots allSatisfy: [:root | root isKindOf: GLMFile])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:05'!
testThereAreSomeDirectoriesUnderRoot
	self assert: (self anyRoot files anySatisfy: [:file | file isDirectory])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/2/2009 19:06'!
testThereAreSomeFilesUnderRoot
	self assert: (self anyRoot files anySatisfy: [:file | file isFile])! !

!GLMFileTest methodsFor: 'tests' stamp: 'DamienCassou 9/23/2009 08:15'!
testThereAreSomeRoots
	self assert: GLMFile roots notEmpty.
	! !

Announcer subclass: #GLMAnnouncingCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:32'!
add: anObject

	collection add: anObject.
	self announce: GLMItemAdded! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:35'!
at: anObject

	^collection at: anObject! !

!GLMAnnouncingCollection methodsFor: 'private' stamp: 'JorgeRessia 11/6/2009 16:35'!
collect: aBlock
	^collection collect: aBlock
	! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:20'!
do: aBlock

	^collection do: aBlock! !

!GLMAnnouncingCollection methodsFor: 'private' stamp: 'JorgeRessia 11/6/2009 16:48'!
includes: anObject 
	^collection includes: anObject! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:18'!
initialize

	collection := OrderedCollection new! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:34'!
isCollection

	^true! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'tg 1/18/2010 21:15'!
printString
	^ collection printString ! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 17:07'!
remove: anObject

	collection remove: anObject.
	self announce: GLMItemRemoved! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'tg 1/19/2010 11:28'!
removeLast

	collection removeLast.
	self announce: GLMItemRemoved! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'tg 1/19/2010 11:29'!
size
	^ collection size! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'JorgeRessia 11/6/2009 16:36'!
withIndexDo: aBlock

	^collection withIndexDo: aBlock! !

Object subclass: #GLMExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMExamples subclass: #GLMBasicExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMBasicExamples commentStamp: '<historical>' prior: 0!
self open!

!GLMBasicExamples classSide methodsFor: 'accessing' stamp: 'tg 2/21/2010 01:06'!
title 
	^ 'Basic Examples'! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/20/2010 16:29'!
accumulator
	<glmBrowser: 'Accumulator' input: '42'>
	"self new accumulator openOn: 42"
	| browser acc |
	browser := GLMTabulator new.
	acc := GLMAccumulator new.
	acc show: [:a | 
		a title: [:x | x asString]. 
		a list title: 'List'; display: [:x | 1 to: x ].
		a text title: 'Text'; display: [:x | 'This is an editor on ', x printString ].
		].
	browser column: [:c | c row: #one span: 4; row: #two]; column: #three.
	browser transmit to: #one; andShow: [:a | 
		a list display: [:x | x to: 10 * x]].
	browser transmit from: #one; to: #two; andShow: [:a |
		a text display: [:x | 'You have selected ', x printString, '. Double cick to open to the right']].
	browser transmit from: #one->#strongSelection; to: #three; andShowIfNone: [:a |
		a custom: acc ].
	browser transmit from: #one; to: #three->#entityToSelect.
	browser transmit from: #three->#activeEntity; to: #one->#selection.
	^ browser
	! !

!GLMBasicExamples methodsFor: 'private' stamp: 'tg 9/25/2010 17:53'!
actionsFor: aPresentation 
	|actions|
	aPresentation isMultiple 
							ifTrue: [actions := (aPresentation selection) ifNil: [OrderedCollection new]]
							ifFalse: [actions := OrderedCollection with: aPresentation selection ].
	^ actions collect: [:i |
					(GLMGenericAction new) 
						action: [:each | Transcript show: 'Menu - Item', i printString; cr]; 
						title: 'Menu - Item', i printString; 
						yourself ]! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:10'!
allowNil
	<glmBrowser: 'Allowing nil' input: '42'>
	"self new allowNil openOn: 42"
	| browser | 
	browser := GLMTabulator new.
	browser 
		column: [: c | c row: #one; row: #two];
		column: #details.
	browser showOn: #one; using: [
		browser tree 
			display: #(1 2 3);
			allowDeselection ].
	browser showOn: #two; using: [
		browser tree 
			display: #(a b c);
			allowDeselection].
	browser showOn: #details; from: #one; from: #two; using: [
		browser text 
			display: [ :one :two | one asString, two asString];
			allowNil ].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 2/21/2010 01:11'!
browserWithToolbar
	<glmBrowser: 'Toolbar' input: '$z'>
	"self new browserWithToolbar openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder act: [:f | f inspect] icon: MenuIcons smallFindIcon entitled: 'Inspect with icon'.
	finder act: [:f | f inspect] entitled: 'Inspect without icon'.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			actions: [:list | self actionsFor: list ].
	^ finder! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 10/25/2010 02:42'!
compoundTaggedTree
	<glmBrowser: 'Tags' input: '#(window help home)'>
	"self new compoundTaggedTree openOn: #(window help home)"
	|browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser tree
			title: 'Combined Tags';
			tags: [:each | { {MenuIcons perform: (each, 'Icon') asSymbol . each asString }}].
		browser tree
			title: 'Image Tags';
			tags: [:each | { MenuIcons perform: (each, 'Icon') asSymbol}].
		browser tree
			title: 'Combined Tags - Filter by image';
			tags: [:each | 
				{ each == #help 
						ifTrue:[ {MenuIcons smallDeleteIcon . 'no ok' } ] 
						ifFalse:[ {MenuIcons smallOkIcon . each asString } ]} ];
			tagsFilter: [:each | 
				{ each == #help 
						ifTrue:[ MenuIcons smallDeleteIcon ] ifFalse:[ MenuIcons smallOkIcon ] } ].
		browser tree
			title: 'Combined Tags - Filter by label';
			tags: [:each | 
				{ {MenuIcons perform: (each, 'Icon') asSymbol.
					each == #help ifTrue:[ 'no ok' ] ifFalse:[ 'ok' ]}} ];
			tagsFilter: [:each | 
				{ each == #help ifTrue:[ 'no ok' ] ifFalse:[ 'ok' ] } ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'composite' stamp: 'tg 2/21/2010 01:12'!
differentComposites
	"self new differentComposites openOn: (1 to: 100)"
	<glmBrowser: 'Composite arrangements' input: '(1 to: 100)'>	
	| browser |
	browser := GLMTabulator new.
	browser row: [:r | 
		r column: #tabbed; column: #accordion; column: #stackedVertically] span: 4; row: #preview.
	browser transmit to: #tabbed; andShow: [:a | 
		a title: 'Tabs'.
		a list title: 'List'. a text title: 'Text' ].
	browser transmit to: #accordion; andShow: [:a | 
		a accordionArrangement.
		a title: 'Accordion'.
		a list title: 'List'. a text title: 'Text' ].
	browser transmit to: #stackedVertically; andShow: [:a | 
		a title: 'Stack'.
		a stackedVerticallyArrangement.
		a list title: 'List'. a text title: 'Text' ].
	browser transmit to: #preview; from: #tabbed; andShow: [:a | 
		a text display: [:x | x printString, ' from tabbed' ]].
	browser transmit to: #preview; from: #accordion; andShow: [:a | 
		a text display: [:x | x printString, ' from accordion' ]].
	browser transmit to: #preview; from: #stackedVertically; andShow: [:a | 
		a text display: [:x | x printString, ' from stacked vertically' ]].
	^ browser ! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:10'!
doubleClick
	<glmBrowser: 'Double click' input: '100'>
	"self new doubleClick openOn: 100"
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list display: [:x | 1 to: x]].
	browser showOn: #two; from: #one->#strongSelection; using: [
		browser list display: [:x | 1 to: x]].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'VeronicaUquillas 5/27/2010 17:30'!
dropDownList
	"	| browser |
		browser := self new dropDownList.
		browser openOn: 5. "
	|browser |

	browser := GLMTabulator new.
	browser row: #one  size: 30; row: #two.
	browser showOn: #one; using: [
		browser dropDownList
			display: [:x | 1 to: x ];
			format: [:number | Text string: number printString attribute: TextColor red]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x asNumber * 2]].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'VeronicaUquillas 5/26/2010 14:48'!
dropDownListWithInitialValue
	"	| browser |
		browser := self new dropDownListWithInitialValue.
		browser openOn: 5.
		((browser paneNamed: #one) port: #selection) value: 12. "
	|browser |

	browser := GLMTabulator new.
	browser row: #one  size: 30; row: #two.
	browser showOn: #one; using: [
		browser dropDownList
			display: [:x | (1 to: x) + 10 ];
		   selectedIndex: 2 ].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x asNumber ]].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 4/1/2010 07:03'!
fixSizePanes
	<glmBrowser: 'Fix size pane' input: '5'>
	"self new fixSizePanes openOn: 1"
	| browser |
	browser := GLMTabulator new.
	browser row: #variable; row: #fix size: 20.
	browser transmit to: #fix; andShow: [ :a | a label display: 'Fix size'].
	browser showOn: #variable; using: [browser text display: 'Variable size'].
	^ browser ! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:10'!
interdependentPanes
	<glmBrowser: 'Two inter-dependent panes' input: '5'>
	"self new interdependentPanes openOn: 5"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	browser showOn: #one; from: #two; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 2/21/2010 01:12'!
listsWithUpdatedSelection
	"self new listsWithUpdatedSelection openOn: 10"
	<glmBrowser: 'Updated selection' input: '10'>
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser showOn: #one; using: [
		browser tree
			display: [:x | 1 to: x ]].
	browser showOn: #two; using: [
		browser tree
			display: [:x | 1 to: x + 2 ]].
	browser showOn: #three; using: [
		browser tree
			beMultiple;
			display: [:x | 1 to: x ]].
	browser sendTo: #two->#selection from: #one with: [:x | x + 2].
	browser sendTo: #one->#selection from: #two with: [:x | x - 2].
	browser sendTo: #three->#selection from: #two with: [:x | (1 to: (x - 2)) ].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 7/2/2010 12:47'!
mondrianPainting
	<glmBrowser: 'Mondrian painting' input: '100'>
	"self new mondrianPainting openOn: 100"
	| browser items |
	browser := GLMTabulator withStatusbar.
	items := 50.
	browser act: [:b | 
		items := 10.
		(b paneNamed: #one) presentations first update ] entitled: 'Update'.
	browser act: [:b | 
		(b paneNamed: #one) inspect ] entitled: 'Inspect'.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser mondrian 
			title: 'Numbers in Mondrian tree';
			painting: [:view :number | 
			view shape label.
			view nodes: (1 to: items ).
			view edgesFrom: [:x | x // 3 ].
			view horizontalTreeLayout ]].
	browser showOn: #two; from: #one; using: [
		browser mondrian 
			title: 'Numbers in Mondrian list';
			painting: [:view :number |
				view shape rectangle width: 20; text: #printString; withoutBorder.
				view nodes: (1 to: number).
				view gridLayout ]].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:09'!
morphIcons
	<glmBrowser: 'Morph icons' input: 'OBMorphicIcons selectors select: [:each | (OBMorphicIcons new perform: each) isForm ]'>
	"self new morphIcons openOn: (OBMorphicIcons selectors select: [:each | (OBMorphicIcons new perform: each) isForm ])"
	| browser |
	browser := GLMTabulator new.
	browser column: #list; column: #preview.
	browser title: 'OBMorphicIcons'.
	browser showOn: #list; using: [
		browser list ].
	browser showOn: #preview; from: #list; using: [
		browser morph
			display: [:symbol | 
				(OBMorphicIcons iconNamed: symbol) asMorph ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 11/16/2009 15:11'!
multiInitialSelection
	"
		| browser |
		browser := self new multiInitialSelection.
		browser openOn: 5.
		(browser panes first port: #selection) value: #(2 5 3).
	"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			beMultiple;
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list ].
	^ browser! !

!GLMBasicExamples methodsFor: 'searching and filtering' stamp: 'tg 2/21/2010 01:13'!
multipleFinderWithFilter
	<glmBrowser: 'Filter' input: '$a to: $z'>
	"self new multipleFinderWithFilter openOn: ($a to: $z)"

	| finder |	
	finder := GLMFinder new.
	finder list
			title: 'List';
			beMultiple;
			actions: [:list | self actionsFor: list];
			filterOn: [:text :each | Compiler evaluate: '| each | each := self. ', text for: each logged: false ].
	finder tree
			title: 'Tree';
			actions: [:list | self actionsFor: list];
			filterOn: [:text :each | Compiler evaluate: '| each | each := self. ', text for: each logged: false ].
	^ finder ! !

!GLMBasicExamples methodsFor: 'searching and filtering' stamp: 'tg 2/21/2010 01:12'!
multipleFinderWithFilterAndSearch
	<glmBrowser: 'Search' input: '$a to: $z'>
	"self new multipleFinderWithFilterAndSearch openOn: (1 to: 100)"

	| finder |	
	finder := GLMFinder new.
	finder list
			beMultiple;
			title: 'Simple';
			actions: [:list | self actionsFor: list].
	finder list
			title: 'With filter';
			beMultiple;
			actions: [:list | self actionsFor: list];
			filterOn: [:text :each | (Compiler evaluate: '[:each | ', text, ']') value: each].
	finder list
			title: 'With search';
			beMultiple;
			actions: [:list | self actionsFor: list];
			searchOn: [:text :each | (Compiler evaluate: '[:each | ', text, ']') value: each].
	^ finder ! !

!GLMBasicExamples methodsFor: 'tabs examples' stamp: 'tg 2/21/2010 01:13'!
multipleTabs
	<glmBrowser: 'Tabs' input: '1'>
	"self new multipleTabs openOn: 1"
	
	| finder |
	finder := GLMFinder new.
	(1 to: 3) do: [:i | 
		finder text
			title: i printString;
			display: [:x | i printString].
		finder text
			titleIcon: MenuIcons smallFindIcon;
			display: [:x | i printString]
	].
	
	^ finder! !

!GLMBasicExamples methodsFor: 'actionlist' stamp: 'tg 2/21/2010 01:11'!
simpleActionList
	<glmBrowser: 'Action list' input: '#(1 2 3)'>	
	"self new simpleActionList openOn: #(1 2 3)"
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser actionList
			act: [:entity | Transcript show: entity ] entitled: 'Transcript';
			act: [:entity | entity inspect ] entitled: 'Inspect'].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 2/21/2010 01:11'!
simpleFinderWithMenu
	<glmBrowser: 'Browser menu' input: '$z'>
	"self new simpleFinderWithMenu openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			actions: [:list | self actionsFor: list ].
	^ finder! !

!GLMBasicExamples methodsFor: 'table' stamp: 'tg 4/20/2010 16:03'!
simpleTable
	<glmBrowser: 'Simple table' input: '100'>
	"self new simpleTable openOn: 1000"
	| finder |	
	finder := GLMFinder new.
	finder table
			display: [ :x | 1 to: x ]; 
			actions: [ :list | self actionsFor: list ];
			column: [:x | 'Numbers from 1 to ', x asString] evaluated: #asString;
			column: 'Even' evaluated: [ :each | each even asString ];
			column: 'Odd' evaluated: [ :each | each odd asString ].
	^ finder! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 11/16/2009 15:11'!
singleInitialSelection
	"
		| browser |
		browser := self new singleInitialSelection.
		browser openOn: 5.
		(browser panes first port: #selection) value: 3.
	"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			display: [:x | 1 to: x];
			format: [:number | Text string: number printString attribute: TextColor red]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 2]].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 7/31/2010 01:15'!
stacker
	<glmBrowser: 'Stacker' input: '5'>
	"self new stacker openOn: 5"
	
	| browser |
	browser := GLMStacker new.
	browser aPane: #x; aPane: #y.
	browser transmit to: #x; andShow: [ :a | 
		a title: 'x'.
		a list display: [:x | 1 to: x ]].
	browser transmit from: #x; to: #y; andShow: [:a | 
		a title: '10 * x'.
		a list display: [:x |  1 to: (10*x )] ].
	^ browser ! !

!GLMBasicExamples methodsFor: 'others' stamp: 'VeronicaUquillas 5/20/2010 12:32'!
starBrowser
	"self new starBrowser openOn: { Boolean. String. #asString. #printString }"

	| browser accumulator |
	browser := GLMTabulator new.
	browser title: 'StarBrowser Light'.
	browser column: #tree; column: #browser span: 4.
	browser showOn: #tree; using: [ browser list ].
	accumulator := GLMAccumulator new.
	accumulator show: [ :a |
		a title: [:object | object printString ].
		a morph
			display: [ :object |
				| model |
				" create omnibrowser model "
				model := object isBehavior
					ifTrue: [ OBHierarchyBrowser onClass: object ]
					ifFalse: [ OBImplementorsBrowser root: (OBSelectorNode on: object) ].
				" create omnibrowser morph, but get rid of window "
				PanelMorph new
					layoutPolicy: ProportionalLayout new;
					addAllMorphs: (OBMorphBuilder build: model) paneMorphs;
					yourself ] ].
	browser transmit to: #browser; from: #tree->#strongSelection; andShowIfNone: [ :a |
		a custom: accumulator ].
	^ browser ! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 9/25/2010 17:55'!
staticAndDynamicMenu
	<glmBrowser: 'Menus' input: '$z'>
	"self new staticAndDynamicMenu openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			actions: [:list | self actionsFor: list ];
			act: [Transcript show: 'static action'; cr] entitled: 'Static action';
			act: [Transcript show: 'static sub action'; cr] entitled: 'Static sub action' categorized: 'Sub menu'.
	finder text
			title: 'Text';
			display: [:each | 'Character ', each asString];
			actions: [:text | OrderedCollection with: (GLMGenericAction new title: 'Print selection'; action: [Transcript show: text selection]; yourself) ];
			act: [Transcript show: 'Text static action'] entitled: 'Static action'.
	^ finder! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 2/21/2010 19:55'!
tableWithIcons
	<glmBrowser: 'Icons' input: '($A to: $z)'>
	"self new tableWithIcons openOn: ($A to: $z)"
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser table
			column: 'Character' evaluated: [ :each | each asString ];
			column: 'ASCII' evaluated: [ :each | each asInteger printString ];
			act: [:tree | tree inspect ] on: $i entitled: 'Inspect';
			icon: [:x | MenuIcons helpIcon ]].
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:08'!
taggedTree
	"self new taggedTree openOn: #(1 2 3 4 5)"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			tags: [:each | 
				{each even ifTrue: ['even'] ifFalse: ['odd'].
				each even ifTrue: ['x'] ifFalse: ['y']}
				]].
	browser showOn: #two; from: #one; using: [
		browser text
			display: [:x | 'You have selected ', x printString ]].
	^ browser! !

!GLMBasicExamples methodsFor: 'text' stamp: 'tg 11/16/2009 15:11'!
textPortsExamples
	"
		self new textPortsExamples openOn: 'Type and select to see the results previewed.'
	"
	| browser |
	browser := GLMTabulator new.
	browser row: #main; row: [:r | r column: #selected; column: #full].
	browser showOn: #main; using: [browser text].
	browser showOn: #selected; from: #main->#selectedText; using: [browser text].
	browser showOn: #full; from: #main->#text; using: [browser text].
	^ browser! !

!GLMBasicExamples methodsFor: 'text' stamp: 'tg 4/15/2010 23:40'!
textSelectionInterval
	<glmBrowser: 'Text selection' input: '(1 to: 100)'>
	"	|browser |
		browser := self new textSelectionInterval.
		browser openOn: (1 to: 100).
		((browser paneNamed: #start) port: #selection) value: 2.
		((browser paneNamed: #end) port: #selection) value: 5.		
	"
	| browser |
	browser := GLMTabulator new.
	browser row: [ :r | r column: #start; column: #end ]; row: #text.
	browser transmit to: #start; andShow: [ :a | a list title: 'Start' ].
	browser transmit to: #end; andShow: [ :a | a list title: 'End' ].
	browser transmit to: #text; andShow: [ :a | 
		a text 
			title: 'Text with selection';
			display: 'some piece of text to test the selection interval on.'].
	browser transmit to: #text->#selectionInterval; from: #start; from: #end; when: [:s :e | s notNil & e notNil] ; transformed: [ :s :e | s to: e ].
"	browser transmit to: #start->#selection; from: #text->#selectionInterval; transformed: [:interval | interval first].
	browser transmit to: #end->#selection; from: #text->#selectionInterval; transformed: [:interval | interval last].
"	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 2/21/2010 01:23'!
threeInterdependentPanes
	<glmBrowser: 'Three inter-dependent panes' input: '5'>
	"self new threeInterdependentPanes openOn: 5"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser showOn: #one; using: [
		browser tree
			display: [:x | 1 to: x]].
	browser showOn: #two; from: #one; using: [ 
		browser tree
			display: [:x | 1 to: x*2]].
	browser showOn: #three; from: #two; using: [
		browser tree
			display: [:x | 1 to: x*3];
			populate: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
	browser sendTo: #outer->#focus from: #three->#focus with: [:x | x ].
	browser sendTo: #one->#selection from: #outer->#focus with: [:x | x ].
	browser sendTo: #two->#selection from: #outer->#focus with: [:x | x ].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 1/22/2010 21:39'!
treeWithAmountFiltering
	<glmBrowser: 'Smart lists' input: '(1 to: 10000)'>
	"self new treeWithAmountFiltering openOn: (1 to: 10000)"
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser tree
			tags: [ :each | {each even printString} ];
			showOnly: 50 ].
	^ browser ! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 11/2/2010 21:05'!
treeWithChildrenByLevel
	<glmBrowser: 'Tree with children by level' input: '(1 to: 5)'>
	"
		self new treeWithChildrenByLevel openOn: #(1 2 3 4 5)
	"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: [:c | c row: #two; row: #three].
	browser transmit to: #one; andShow: [ :a |
		browser tree
			title: 'Tree';
			children: [:item :x :level | level > 1 ifTrue: [#()] ifFalse: [1 to: item ] ] "Children must return a collection"].
	browser transmit to: #two; from: #one; andShow: [:a | 
		a text title: 'Selection preview' ].
	browser transmit to: #three; from: #one->#selectionPath; andShow: [:a | 
		a text title: 'Selection path preview'].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 1/15/2010 11:26'!
treeWithExpansion
	<glmBrowser: 'Tree with expansion' input: '#(($a $b $c $d) ($e $f) ($g $h $i $j ($l $m $n)))'>
	"self new treeWithExpansion openOn: #(($a $b $c $d) ($e $f) ($g $h $i $j ($l $m $n)))"
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			title: 'No expansion';
			children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ].
		browser tree
			title: 'Roots expanded';
			rootsExpanded;
			children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ].
		browser tree
			title: 'All expanded';
			allExpanded;
			children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ] ].
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 1/14/2010 15:35'!
treeWithInitialSelection
	"
		| browser |
		browser := self new treeWithInitialSelection. 
		browser openOn: {
			#first->{$a->{}. $c->{}. $d->{}}.
			#second->{$e->{}. $f->{}}. 
			#third->{$h->{}}
		}.
		(browser panes first port: #selection) value: $a->{}.
	"
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: [:c | c row: #two; row: #three].
	browser showOn: #one; using: [
		browser tree
			title: 'first tree';
			children: [:x | x value ].
		browser tree
			title: 'second tree';
			children: [:x | x value ]].
	browser showOn: #two; from: #one; using: [ browser text title: 'Selection preview' ].
	browser showOn: #three; from: #one->#selectionPath; using: [ browser text title: 'Selection path preview'].
	^ browser! !

!GLMBasicExamples methodsFor: 'actions examples' stamp: 'tg 2/21/2010 01:12'!
treeWithMenu
	<glmBrowser: 'Tree with menu' input: '#(($a $b $c $d) ($e $f) ($g $h $i $j $l))'>
	"self new treeWithMenu openOn: #(($a $b $c $d) ($e $f) ($g $h $i $j $l))"
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ];
			act: [:tree | tree inspect ] on: $i entitled: 'Inspect';
			icon: [:x | MenuIcons helpIcon ]].
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'updating' stamp: 'tg 7/16/2010 07:14'!
updatableBrowser
	"
	|collection|
	collection := GLMAnnouncingCollection new.
	collection add: 1; add: 2; add: 3.
	self new updatableBrowser openOn: collection.
	collection inspect"
	
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser act: [:b | b entity add: (browser entity size + 1) ] entitled: 'Add an item in the collection'.
	browser act: [:b | b entity removeLast ] entitled: 'Remove last item from the collection'.
	browser transmit to: #one; andShow: [ :a |
		a title: 'Updated automatically'.
		a stackedArrangement.
		a list title: [:x | 'List: ', x size printString ];
			shouldValidate: true;
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself.
		a text title: 'Text';
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself .
		a mondrian title: 'Mondrian';
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself;
			painting: [:view :entity | 
				view shape label.
				view nodes: entity ] ].
	browser transmit to: #two; andShow: [ :a |
		a title: 'Updated via menu'.
		a stackedArrangement.
		a list title: 'List';
			shouldValidate: true;
			act: [:p | p update] entitled: 'Update'.
		a text title: 'Text'; act: [:p | p update] entitled: 'Update'.
		a mondrian title: 'Mondrian';
			act: [:p | p update] entitled: 'Update';
			painting: [:view :entity | 
				view shape label.
				view nodes: entity ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'text' stamp: 'tg 2/21/2010 01:23'!
updateAction
	<glmBrowser: 'Update action' input: 'String withAll: ''Select a piece of text and open on the next pane via the contextual menu or by pressing Modifier+o. Otherwise just open the complete copy of the current text on the next pane via the menu or by pressing Modifier+l.'''>
	"self new updateAction openOn: 'Select a piece of text and open on the next pane'"
	| browser |
	browser := GLMFinder new.
	browser text
		populate: #selection on: $o entitled: 'Open selection on next pane' with: [:text | text selectedText ];
		populate: #selection on: $l entitled: 'Open complete text on next pane' with: [:text | text text ].
	^ browser ! !

!GLMExamples classSide methodsFor: 'accessing' stamp: 'AndreiChis 8/19/2010 21:47'!
browser
	"self browseExamples"
	| browser |
	browser := GLMTabulator new.
	browser title: self title.
	browser column: #titles; column: #example span: 4.
	browser showOn: #titles; using: [
		browser list
			display: [:list | list asSortedCollection: [:a :b | 
				(a argumentAt: 1) < (b argumentAt: 1)] ];
			format: [:each | each argumentAt: 1]].
	browser showOn: #example; from: #titles; using: [
		browser dynamic
			title: 'Browser';
			presentation: [ :some :each | 
				some custom: ((self new perform: each selector) startOn: (Compiler evaluate: (each argumentAt: 2) logged: false))].
		browser text 
			title: 'Source code';
			forSmalltalk: self;
			display: [:each | self sourceCodeAt: each selector]].	
	^ browser.! !

!GLMExamples classSide methodsFor: 'accessing' stamp: 'AndreiChis 8/19/2010 21:47'!
model
	^ Pragma allNamed: #glmBrowser:input: in: self.! !

!GLMExamples classSide methodsFor: 'rendering' stamp: 'AndreiChis 8/19/2010 21:47'!
open
	^ self browser openOn: self model! !

!GLMExamples classSide methodsFor: 'accessing' stamp: 'tg 2/21/2010 01:06'!
title
	^ 'Examples'! !

GLMExamples subclass: #GLMOtherExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMOtherExamples commentStamp: '<historical>' prior: 0!
self open!

!GLMOtherExamples methodsFor: 'file examples' stamp: 'tg 11/16/2009 15:11'!
fileExplorer
	<glmBrowser: 'File Explorer' input: 'FileDirectory default'>
	"self new fileExplorer openOn: FileDirectory default"
	| browser |
	browser := GLMTabulator new.
	browser 
		column: #folders;
		column: [ :col | col row: #files span: 2; row: #preview ] span: 2. 
	browser showOn: #folders; using: [
		browser tree 
			title: 'Folders'; 
			children: [ :fd | fd directoryNames collect: [ :each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each ] ]; 
			format: [ :folder | folder localName ] ].
	browser showOn: #files; from: #folders; using: [
		browser list 
			format: [ :fd | fd localName ]; 
			display: [ :fd | fd fileNames collect: [:each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each ] ] ].
	browser showOn: #preview; from: #files; using: [
		browser text
			display: [ :file | file fullName ] ].
	^ browser! !

!GLMOtherExamples methodsFor: 'file examples' stamp: 'tg 11/13/2009 01:48'!
fileFinder
	<glmBrowser: 'File Finder' input: 'FileDirectory default'>
	"self new fileFinder openOn: FileDirectory default"

	| browser |
	browser := GLMFinder new.
	browser list
		display: [ :fd | fd entries collect: [:each | 
				FileDirectory on: fd pathName, fd pathNameDelimiter asString, each name]];
		format: [ :fd | fd localName ];
		when: [ :fd | fd directoryEntry isDirectory ].
	browser text
		display: [ :fd | fd fullName ];
		when: [ :fd | fd directoryEntry isDirectory not ].
	^ browser! !

!GLMOtherExamples methodsFor: 'pier examples' stamp: 'tg 2/21/2010 01:23'!
mondrianEasel
	"self new mondrianEasel openOn: ''"
	| browser |
	browser := GLMTabulator new.
	browser row: #painting span: 10; row: #script span: 4; row: #actions.
	browser showOn: #script; using: [
		browser text
			display: 'view';
			populate: #selection on: $o entitled: 'Generate View' with: [:text | text text ] ].
	browser showOn: #painting; from: #script; using: [
		browser dynamic
			display: [:script | 
				GLMMondrianPresentation new
					painting: [:view | 
						(Compiler evaluate: 'view := self.', script for: view logged: false)  ]]].
	browser showOn: #actions; using: [
		browser actionList 
			act: [] entitled: 'Generate View' ].
	^ browser! !

!GLMOtherExamples methodsFor: 'pier examples' stamp: 'tg 11/13/2009 01:46'!
pierFinder
	"
		self new pierFinder openOn: PRKernel instances anyOne root.
	"
	| browser |
	browser := GLMFinder new.
	browser list
		display: [:each | each enumerator contents];
		format: [:each | each title];
		title: 'Navigation'.
	browser magritte title: 'Editor'.
	browser mondrian
			title: 'Tree';
			painting: [:view :each | 
				view nodeShape: (MORectangleShape withBorder height: [:x | x plainText size // 10]).
				view nodes: each enumerator everything contents.
				view edgesFrom: #parent.
				view treeLayout].
	^ browser! !

!GLMOtherExamples methodsFor: 'pier examples' stamp: 'tg 11/16/2009 15:11'!
pierTreeEditor

	"
		self new pierTreeEditor openOn: PRKernel instances anyOne root.
	"

	| browser |
	browser := GLMTabulator new.
	browser column: #navigation; column: #editor span: 4.
	browser showOn: #navigation; using: [
		browser tree
			children: [:each | each enumerator contents];
			format: [:each | each title ];
			title: 'Navigation'.
	].
	browser showOn: #editor; from: #navigation; using: [
		browser magritte
			title: 'Editor'.
	].
	^ browser ! !

Object subclass: #GLMFile
	instanceVariableNames: 'pathName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMFile commentStamp: 'DamienCassou 9/2/2009 19:52' prior: 0!
This is a very simple and limited implementation of the java.io.File class. I did that because FileDirectory is just impossible to use and remember. !

!GLMFile classSide methodsFor: 'accessing' stamp: 'DamienCassou 9/23/2009 08:15'!
anyRoot
	^ self roots detect: [:file | [file files notEmpty] on: Error do: [false]] ! !

!GLMFile classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/23/2009 08:15'!
pathName: aString
	^ self new
		setPathName: aString;
		yourself ! !

!GLMFile classSide methodsFor: 'accessing' stamp: 'DamienCassou 9/23/2009 08:15'!
roots
	^ (OSPlatform current platformFamily = #Windows)
		ifTrue: [FileDirectory root fileAndDirectoryNames collect: [:ea | self pathName: ea]]
		ifFalse: [Array with: (self pathName: FileDirectory root fullName)]! !

!GLMFile methodsFor: 'reading' stamp: 'DamienCassou 9/3/2009 10:55'!
contents
	self isFile not ifTrue: [Error signal: 'Only files have content'].
	^ FileStream
		readOnlyFileNamed: pathName
		do: [:stream | stream contents]! !

!GLMFile methodsFor: 'enumerating' stamp: 'DamienCassou 9/22/2009 18:50'!
files
	^ ([(FileDirectory on: pathName) fileAndDirectoryNames]
		on: InvalidDirectoryError do: [:err | Array new])
			collect: [:name | self class pathName: ((FileDirectory on: pathName) fullNameFor: name)]! !

!GLMFile methodsFor: 'testing' stamp: 'DamienCassou 9/2/2009 18:57'!
isDirectory
	^ (pathName = '/') or: [(FileDirectory on: pathName) directoryEntry isDirectory]! !

!GLMFile methodsFor: 'testing' stamp: 'DamienCassou 9/2/2009 19:00'!
isFile
	^ self isDirectory not! !

!GLMFile methodsFor: 'printing' stamp: 'DamienCassou 9/22/2009 19:05'!
name
	^ self tail! !

!GLMFile methodsFor: 'printing' stamp: 'DamienCassou 9/2/2009 19:19'!
nameDistinguishingTypes
	^ self isDirectory 
		ifTrue: [self name, '/']
		ifFalse: [self name]! !

!GLMFile methodsFor: 'printing' stamp: 'DamienCassou 9/22/2009 19:06'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self tail;
		nextPut: $)! !

!GLMFile methodsFor: 'private' stamp: 'DamienCassou 9/2/2009 18:35'!
setPathName: aString
	pathName := aString! !

!GLMFile methodsFor: 'printing' stamp: 'DamienCassou 9/22/2009 19:10'!
tail
	| name |
	name := (FileDirectory on: pathName) localName.
	^ name isEmpty
		ifTrue: [pathName]
		ifFalse: [name]! !

Object subclass: #GLMSTBrowserExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'lr 2/19/2010 09:45'!
browser
	"
	self new browser openOn: (BrowserEnvironment new forPackageNames: #('Glamour'))
	"

	| browser |

	browser := GLMTabulator new.
	browser row: [ :row | 
		row 
			column: #category;
			column: #class;
			column: #protocol;
			column: #selector ].
	browser row: #source.
	
	" categories "
	self categoriesOn: browser.
	self classesOn: browser.
	self protocolsOn: browser.
	self selectorsOn: browser.
	self sourceOn: browser.
	
	^ browser! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:09'!
categoriesOn: browser
	browser showOn: #category; using: [
		browser list
			display: [ :environment | environment categories ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:09'!
classesOn: browser
	browser showOn: #class; from: #outer -> #entity; from: #category; using: [
		browser list
			title: 'Instance';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta not ])
					select: [ :each | each category = category ])
					asSortedCollection: [ :a :b | a name < b name ] ];
			format: [ :class | class name ].
		browser list
			title: 'Class';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta ])
					select: [ :each | each theNonMetaClass category = category ])
					asSortedCollection: [ :a :b | a name < b name ] ];
			format: [ :class | class theNonMetaClass name ] ]! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'lr 2/27/2009 10:35'!
model
	^ BrowserEnvironment new forPackageNamed: 'Glamour'! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:08'!
protocolsOn: browser
	browser showOn: #protocol; from: #outer -> #entity; from: #class; using: [
		browser list
			when: [ :environment :class | class notNil ];
			display: [ :environment :class | 
				(environment protocolsFor: class)
					asSortedCollection ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/19/2010 09:46'!
selectorsOn: browser
	browser showOn: #selector; from: #outer -> #entity; from: #class; from: #protocol; using: [
		browser list
			useExplicitNotNil;
			when: [ :environment :class :protocol | class notNil and: [ protocol notNil ] ];
			display: [ :environment :class :protocol | (environment selectorsFor: protocol in: class) asOrderedCollection ].
		browser list
			useExplicitNotNil;
			when: [ :environment :class :protocol | class notNil and: [ protocol isNil ] ];
			display: [ :environment :class :protocol | (environment selectorsForClass: class) asOrderedCollection ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/19/2010 09:47'!
sourceOn: browser
	browser showOn: #source; from: #category; from: #class; from: #selector; using: [
		browser text
			title: 'Source';
			useExplicitNotNil;
			when: [ :category :class :selector | class notNil and: [ selector notNil ] ];
			display: [ :category :class :selector | class sourceCodeAt: selector ifAbsent: [ String new ] ].
		browser text
			title: 'Source';
			useExplicitNotNil;
			when: [ :category :class :selector | class notNil and: [ selector isNil ] ];
			display: [ :category :class :selector | class definition ].
		browser mondrian
			title: 'Complexity';
			useExplicitNotNil;
			painting: [ :view :category :class :selector |
				view nodeShape 
					height: [ :model | model linesOfCode min: 50 max: 5 ];
					width: [ :model | model instVarNames size + 5 ];
					fillColor: [ :model | model = class ifTrue: [ Color red ] ifFalse: [ Color white ] ].
				view nodes: (((Smalltalk organization listAtCategoryNamed: category)
					collect: [ :each | Smalltalk classNamed: each ])
					reject: [ :each | each isTrait ]).
				view edgesFrom: [ :each | each superclass ].
				view treeLayout ];
			when: [ :category :class :selector | category notNil ] ]! !
